<template>
  <div class="_container">
    <h1>{{ resourceInteractionsGroup.name }}</h1>

    <rui-actions>
      <rui-button @click="$emitBus('edit-resource-interactions-group', resourceInteractionsGroup)">{{ $t('generic.edit') }}</rui-button>
    </rui-actions>

    <gp-markdown-renderer :content="resourceInteractionsGroup.description" />

    <div class="-grid-2 -gap">
      <section>
        <div class="-flex -gap">
          <h2>{{ $t('js.resource_interactions_group.item.interactions') }}</h2>
          <rui-button icon="plus"
                      variant="creative"
                      :title="$t('js.resource_interaction.list.new_resource_interaction')"
                      @click="showNewResourceInteractionForm" />
        </div>
        <gpa-resource-interactions-list :resource-interactions-group="resourceInteractionsGroup" :editable="true" />
      </section>

      <section>
        <h2>{{ $t('js.resource_interactions_group.item.resources') }}</h2>
        <rui-empty v-if="resources.length === 0" :content="$t('js.resource_interactions_group.item.no_resource')" />
        <template v-else>
          <ul class="-unstyled">
            <li v-for="resource in resources" :key="resource.id">
              <router-link :to="{name: 'library', params:{resourceId: resource.id}}">{{ resource.name }}</router-link>
            </li>
          </ul>
        </template>
      </section>
    </div>
  </div>
</template>
<script>
import RuiActions from '@experiments-labs/rise_ui/src/components/Actions/Actions.vue'
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'

import ResourceInteractionsGroup from '../../../../classes/models/ResourceInteractionsGroup'
import GpMarkdownRenderer from '../../../../common/DataDisplay/MarkdownRenderer/MarkdownRenderer.vue'
import GpaResourceInteractionsList from '../ResourceInteractions/_List.vue'

export default {
  name: 'GpaResourceInteractionsGroupItem',
  components: { RuiEmpty, RuiButton, RuiActions, GpaResourceInteractionsList, GpMarkdownRenderer },
  props: {
    resourceInteractionsGroup: { required: true, type: ResourceInteractionsGroup },
  },
  computed: {
    resources () { return this.resourceInteractionsGroup.resources },
    resourceInteractions () { return this.$store.getters.positiveInteractionsByGroup(this.resourceInteractionsGroup.id) },
  },
  methods: {
    showNewResourceInteractionForm () {
      this.$emitBus('show-resource-interaction-form', { resourceInteraction: null, subjectId: this.$props.resourceInteractionsGroup.id })
    },
  },
}
</script>
